<?php
namespace MyMenu\Controllers;
use MyMenu\Services\JWT;
use MyMenu\Libraries\KeyValueStorage;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;

class Authenticator {
   // protected $authenticator;
   private $crudService;

    public function __construct($crudService) {
        $this->crudService  = $crudService;
    }
    
    
    public function authenticator(Request $request, Response $response) {
        $requestHeaders = getallheaders();
        $token = isset($requestHeaders["token"]) ? $requestHeaders["token"] : null;

        if($token) {
            $tokenData = JWT::getTokenData($token);
            if (isset($tokenData['NRUSUARIOAPP']) && isset($tokenData['DSEMAILUSUARIOAPP'])) {
                $user = $tokenData['NRUSUARIOAPP'];
                $email = $tokenData['DSEMAILUSUARIOAPP'];
                
                $conditions = array(
                    array(
                        "columnName" => "NRUSUARIOAPP",
                        "operator" => "=",
                        "value" => $user,
                    ),
                    array(
                        "columnName" => "DSEMAILUSUARIOAPP",
                        "operator" => "=",
                        "value" => $email,
                    ),
                );
                
                $resDataSet = $this->crudService->getFilteredDataSet('usuarioapp_login', $conditions, 1, 1);
                
                if (sizeof($resDataSet->getRows()) == 1) {
                    $userData = $resDataSet->getRows()[0];
                    
                    $isNewUser = $userData['USUARIOATIVO'] === null;
                    if ($userData['USUARIOATIVO'] == 'S' || $isNewUser) {
                        $response->addDataSet(new DataSet('user', [true]));
                    } else {
                        $response->addDataSet(new DataSet('user', [false]));
                    }
                }
            }
        } else {
            $response->addDataSet(new DataSet('user', [true]));
        }
    }
}
