function LocalPlateDataService(){
    let cache = JSON.parse(localStorage.getItem('savedCons')) || [];
    
    const _findPlateFunction = function(plate) {
        return sc => 
            // sc.CDFILCENTPME == plate.CDFILCENTPME &&
            // sc.CDTIPOCARD == plate.CDTIPOCARD &&
            // sc.NRCARDPME == plate.NRCARDPME &&
            // sc.CDDIETPAD == plate.CDDIETPAD &&
            sc.CDFILIAL == plate.CDFILIAL &&
            sc.CDSERVFILI == plate.CDSERVFILI &&
            sc.NRCARDAPIO == plate.NRCARDAPIO &&
            sc.NRSEQPRATCAR == plate.NRSEQPRATCAR &&
            sc.CDFILAUXPRAT == plate.CDFILAUXPRAT &&
            sc.CDPRATO == plate.CDPRATO &&
            sc.DTCARDAPIO == plate.DTCARDAPIO &&
            sc.CDTIPOPRAT == plate.CDTIPOPRAT &&
            sc.NRORG == plate.NRORG;
    };
    
    const findPlate = function(plate) {
        const findKeys = _findPlateFunction(plate);
        return cache.find(findKeys);
    };
    
    const findPlateIndex = function(plate) {
        const findKeys = _findPlateFunction(plate);
        return cache.findIndex(findKeys);
    };
    
    const hasPlate = function(plate) {
        return !!findPlate(plate);
    };
    
    this.plateIsBookmarked = function(plate) {
        const cachePlate = findPlate(plate);
        return cachePlate && cachePlate.IDCONSUMO;
    };
    
    this.isPlateRated = function(plate){
        const cachePlate = findPlate(plate);
        return cachePlate && cachePlate.VRAVALIACAOPRATO;
    };
    
    const update = function(plate) {
        const plateIndex = findPlateIndex(plate);
        cache[plateIndex] = plate;
        setLocalVar('savedCons', cache);
        console.log('update called with params:', plate);
    };
    
    const insert = function(plate){
        cache.push(plate);
        setLocalVar('savedCons', cache);
        console.log('insert called with params:', plate);
    };
    
    this.saveRating = function(plate) {
        let cachePlate = findPlate(plate);
        
        if(!cachePlate){
            insert(plate);
            cachePlate = plate;
        }
        
        cachePlate.DSAVALICAO = plate.DSAVALICAO;
        cachePlate.VRAVALIACAOPRATO = plate.VRAVALIACAOPRATO;
        
        update(cachePlate);
    };
    
    this.saveBookmark = function(plate) {
        let cachePlate = findPlate(plate);
        
        if(!cachePlate){
            insert(plate);
            cachePlate = plate;
        }
        
        cachePlate.IDCONSUMO = plate.IDCONSUMO;
        cachePlate.NMUSUARIO = plate.NMUSUARIO;
        cachePlate.HRCONSUMO = plate.HRCONSUMO;
        cachePlate.NRAVALIACAOPRATO = plate.NRAVALIACAOPRATO;
        
        update(cachePlate);
    };
    
    this.findPlate = findPlate;
    this.hasPlate = hasPlate;
    this.insert = insert;
    this.update = update;
    this.reloadCache = () => {
        cache = JSON.parse(localStorage.getItem('savedCons')) || [];
    };
}


Configuration(function (ContextRegister) {
    ContextRegister.register('LocalPlateDataService', LocalPlateDataService);
});