var PopupControllerUtil = {
	getInstanceOnOpenPopup: function() {
		if (!this.onOpenPopup) {
			/**
			 * Default event that handles an openPopup event
			 *
			 * @param event The angular broadcast event
			 * @param widget The widget to open
			 * @param deferred The deferred to be resolved when the handler finishes its job
			 */
			this.onOpenPopup = function(event, widget, deferred) {
				var self = PopupControllerUtil;
				self.$scope.widget = widget;
				self.$rootScope.popupOpen = true;
				if (widget.popupNoBlock) {
					$(document).on('mousedown', self.parent._documentMouseDown);
					$(document).on('touchstart', self.parent._documentMouseDown);
				}
				if (deferred) {
					deferred.resolve();
				}
			};
		}
		return this.onOpenPopup;
	}
};

function PopupController($scope, ScreenService, templateManager, eventEngine, $rootScope, $timeout) {
	var self = this;
	PopupControllerUtil.parent = this;
	PopupControllerUtil.$scope = $scope;
	PopupControllerUtil.$timeout = $timeout;
	PopupControllerUtil.$rootScope = $rootScope;
	$scope.$on("openPopup", PopupControllerUtil.getInstanceOnOpenPopup());
	this._documentMouseDown = function(e) {
		if ($(e.target).closest('.popup-container').length === 0 && $('.popup-container').is(':visible')) {
			$rootScope.$apply(function() {
				ScreenService.closePopup();
			});
			$(document).off('mousedown', this._documentMouseDown);
			$(document).off('touchstart', this._documentMouseDown);
		}
	};
	$scope.$on("closePopup", function(e) {
		$(document).off('mousedown', this._documentMouseDown);
		$(document).off('touchstart', this._documentMouseDown);
	});
	$scope.$on("changeContainer", function(e, widget) {
		ScreenService.closePopup();
	});

	$scope.closePopup = function() {
		ScreenService.closePopup();
	};

	$scope.actionClick = Util.buildDebounceMethod(function(action, widget, row) {
		// copia do ZeedhiControler.actionClick... refatorar// there is no problem here
		if (!action.aclReadOnly && !action.readOnly) {
			if (row) {
				widget.currentRow = row;
			}
			$scope.currentWidget = widget;
			templateManager.currentWidget = widget;
			var events = action.events;
			if (events) {
				eventEngine.bindEvents(action, events, function() {
					return widget.dataSource;
				}, function() {
					return widget.currentRow;
				}, function() {
					return widget.selectedRow;
				});
			}
			action.click();
		}
	}, 300, true);

	$scope.getIconClass = function(action, widget) {
		var classes = "";
		if (action.icon) {
			classes = action.icon;
			if (widget.popupNoBlock) {
				classes += ' icon-white';
			} else {
				classes += ' color-main';
			}
		}
		return classes;
	};
}